## bowtie2 2.5.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0005 NEW)

file(STRINGS ${CMAKE_SOURCE_DIR}/BOWTIE2_VERSION PROJECT_VERSION)
project(bowtie2 LANGUAGES C CXX VERSION ${PROJECT_VERSION})

enable_testing()

include(CTest)
include(ExternalProject)
include(ProcessorCount)
include(CheckSymbolExists)

ProcessorCount(NUM_CORES)

option(BOWTIE_MM "enable bowtie2 memory mapping" ON)
option(BOWTIE_SHARED_MEM "enable shared memory mapping" OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
if (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
   set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()
set(USE_SRA ${USE_SRA})
set(USE_SAIS ${USE_SAIS})
set(WITH_THREAD_PROFILING ${WITH_THREAD_PROFILING})
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g3 -Wall")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -funroll-loops")
set(INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin" CACHE PATH "Installation directory for executables")


include_directories(${CMAKE_SOURCE_DIR}/third_party)
message("${CMAKE_SOURCE_DIR}/third_party")
if (MINGW)
  option(BOWTIE_MM "Memory mapped files not supported on Windows" OFF)
  option(BOWTIE_SHARED_MEM "Shared memory not supported on Windows" OFF)
endif(MINGW)

if (APPLE)
  set(CMAKE_XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif(APPLE)

set(BOWTIE2_BIN_LIST
  bowtie2-build-s
  bowtie2-build-l
  bowtie2-align-s
  bowtie2-align-l
  bowtie2-inspect-s
  bowtie2-inspect-l
  )

set(BOWTIE2_WRAPPER_SCRIPTS
  bowtie2
  bowtie2-build
  bowtie2-inspect
  )

set(SHARED_CPPS
  ccnt_lut.cpp
  ref_read.cpp
  alphabet.cpp
  shmem.cpp
  edit.cpp
  bt2_idx.cpp
  bt2_io.cpp
  bt2_locks.cpp
  bt2_util.cpp
  reference.cpp
  ds.cpp
  multikey_qsort.cpp
  limit.cpp
  random_source.cpp
  )

set(SEARCH_CPPS
  qual.cpp pat.cpp sam.cpp
  read_qseq.cpp aligner_seed_policy.cpp
  aligner_seed.cpp
  aligner_seed2.cpp
  aligner_sw.cpp
  aligner_sw_driver.cpp aligner_cache.cpp
  aligner_result.cpp ref_coord.cpp mask.cpp
  pe.cpp aln_sink.cpp dp_framer.cpp
  scoring.cpp presets.cpp unique.cpp
  simple_func.cpp
  random_util.cpp
  aligner_bt.cpp sse_util.cpp
  aligner_swsse.cpp outq.cpp
  aligner_swsse_loc_i16.cpp
  aligner_swsse_ee_i16.cpp
  aligner_swsse_loc_u8.cpp
  aligner_swsse_ee_u8.cpp
  aligner_driver.cpp
  bowtie_main.cpp
  bt2_search.cpp
  )

set(BUILD_CPPS
  bt2_build.cpp
  diff_sample.cpp
  bowtie_build_main.cpp)

set(INSPECT_CPPS
  bt2_inspect.cpp
  )

string(TIMESTAMP BUILD_DATE)
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -v OUTPUT_VARIABLE COMPILER_VERSION)

add_definitions(
  -DBOWTIE2
  -DBUILD_HOST="${CMAKE_HOST_SYSTEM}"
  -DBUILD_TIME="${BUILD_DATE}"
  -DCOMPILER_VERSION="${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}"
  -DBOWTIE2_VERSION="${PROJECT_VERSION}"
  -D_LARGEFILE_SOURCE
  -D_FILE_OFFSET_BITS=64
  -D_GNU_SOURCE
  )

if (BOWTIE_MM)
  add_definitions(-DBOWTIE_MM)
endif()

if (BOWTIE_SHARED_MEM)
  add_definitions(-DBOWTIE_SHARED_MEM)
endif()

if (WITH_AFFINITY)
  add_definitions(-DWITH_AFFINITY=1)
endif()

if (NO_SPINLOCK)
  add_definitions(-DNO_SPINLOCK)
endif()

if (NOT NO_QUEUELOCK)
  add_definitions(-DNO_SPINLOCK)
  add_definitions(-DWITH_QUEUELOCK=1)
endif()

 execute_process(COMMAND uname -m OUTPUT_VARIABLE ARCH)
if (${ARCH} MATCHES aarch64|arm64|390x|ppc64|ppc64le)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp-simd")
elseif (${ARCH} MATCHES amd64|x64_64)
  add_definitions(-DPOPCNT_CAPABILITY)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
endif()

if (WITH_THREAD_PROFILING)
  add_definitions(-DPER_THREAD_TIMING=1)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Release")
  add_definitions(-DNDEBUG)
else()
  message("--------------------------------------------------------------------------")
  message("ATTN: Targets built in debug mode will have `-debug' appended to its name.")
  message("See https://cmake.org/cmake/help/latest/variable/CMAKE_BUILD_TYPE.html")
  message("--------------------------------------------------------------------------")
  set(CMAKE_EXECUTABLE_SUFFIX "-debug")
endif()

find_package(ZLIB REQUIRED)

find_package(Threads REQUIRED)
link_libraries(Threads::Threads)

if (ZLIB_FOUND)
  link_libraries(${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIRS})
endif()

include_directories(${PROJECT_SOURCE_DIR})
get_directory_property(COMPILER_DEFS COMPILE_DEFINITIONS)
string(REPLACE ";" " -D" COMPILER_DEFS "${COMPILER_DEFS}")
string(REPLACE "\"" "" COMPILER_DEFS "${COMPILER_DEFS}")
add_definitions(-DCOMPILER_OPTIONS="${CMAKE_CXX_FLAGS} -D${COMPILER_DEFS}")

if (USE_SRA)
  set(SRA_TOOLS_VER 3.0.9)
  set(NCBI_VDB_VER 3.0.9)

  set(THIRD_PARTY_LIBS "${PROJECT_SOURCE_DIR}/third_party")

  find_package(Java COMPONENTS Development REQUIRED)
  find_package(PythonInterp REQUIRED)
  find_package(Perl REQUIRED)
  find_program(MAKE_EXE NAMES gmake nmake make)

  # ExternalProject_add(ncbi_vdb_project
  #   URL https://github.com/ncbi/ncbi-vdb/archive/refs/tags/${NCBI_VDB_VER}.tar.gz
  #   PREFIX ${CMAKE_CURRENT_BINARY_DIR}/ncbi-vdb-${NCBI_VDB_VER}
  #   BUILD_IN_SOURCE 0
  #   # CONFIGURE_COMMAND ./configure --prefix=${THIRD_PARTY_LIBS} --without-debug
  #   BUILD_COMMAND cmake .  -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=${THIRD_PARTY_LIBS}
  #   # BUILD_COMMAND ${MAKE_EXE}
  #   INSTALL_COMMAND ${MAKE_EXE} install
  #   )

  ExternalProject_add(ncbi_vdb_project
    URL https://github.com/ncbi/ncbi-vdb/archive/refs/tags/${NCBI_VDB_VER}.tar.gz
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/ncbi-vdb-${NCBI_VDB_VER}
    BUILD_IN_SOURCE 1
    # CONFIGURE_COMMAND ./configure --prefix=${THIRD_PARTY_LIBS} --without-debug
    CONFIGURE_COMMAND cd build && cmake ..  -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=${THIRD_PARTY_LIBS}
    BUILD_COMMAND cmake --build build
    INSTALL_COMMAND cmake --install build
    )

  ExternalProject_add(ngs_project
    URL https://github.com/ncbi/sra-tools/archive/refs/tags/${SRA_TOOLS_VER}.tar.gz
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}/sra-tools-${SRA_TOOLS_VER}
    BUILD_IN_SOURCE 1
    CONFIGURE_COMMAND cd build && cmake .. -DCMAKE_BUILD_TYPE=Release -DVDB_INCDIR=${THIRD_PARTY_LIBS}/include -DVDB_LIBDIR=${THIRD_PARTY_LIBS}/lib64 -DCMAKE_INSTALL_PREFIX=${THIRD_PARTY_LIBS} -DBUILD_TOOLS_INTERNAL=ON -DBUILD_TOOLS_LOADERS=OFF -DBUILD_TOOLS_TEST_TOOLS=OFF
    BUILD_COMMAND cmake --build build

    INSTALL_COMMAND cmake --install build
    DEPENDS ncbi_vdb_project
    )

  link_directories(${THIRD_PARTY_LIBS}/lib64)
  include_directories(${THIRD_PARTY_LIBS}/include)

  add_library(ncbi-vdb-static STATIC IMPORTED)
  add_dependencies(ncbi-vdb-static ncbi_vdb_project)
  find_library(LIBNCBI_VDB ncbi-vdb-static PATHS ${THIRD_PARTY_LIBS}/lib64 NO_DEFAULT_PATH)
  set_property(TARGET ncbi-vdb-static PROPERTY IMPORTED_LOCATION ${LIBNCBI_VDB})

  add_library(ncbi-ngs-static STATIC IMPORTED)
  add_dependencies(ncbi-ngs-static ngs_project)
  find_library(LIBNCBI_NGS ncbi-ngs-static PATHS ${THIRD_PARTY_LIBS}/lib64 NO_DEFAULT_PATH)
  set_property(TARGET ncbi-ngs-static PROPERTY IMPORTED_LOCATION ${LIBNCBI_NGS})

  link_libraries(ncbi-ngs-static ncbi-vdb-static dl)
  add_definitions(-DUSE_SRA)
endif()

if (USE_SAIS)
  set(LIBSAIS_VER 2.7.3)

  find_package(OpenMP)
  if (OpenMP_CXX_FOUND)
    link_libraries(OpenMP::OpenMP_CXX)
    ExternalProject_add(libsais_project
      URL https://github.com/IlyaGrebnov/libsais/archive/refs/tags/v${LIBSAIS_VER}.tar.gz
      PREFIX ${CMAKE_CURRENT_BINARY_DIR}/libsais-${LIBSAIS_VER}
      BUILD_IN_SOURCE 1
      DOWNLOAD_EXTRACT_TIMESTAMP false
      CONFIGURE_COMMAND cmake . -D LIBSAIS_USE_OPENMP=1
      BUILD_COMMAND cmake --build .
      INSTALL_COMMAND ""
    )
  else()
    ExternalProject_add(libsais_project
      URL https://github.com/IlyaGrebnov/libsais/archive/refs/tags/v${LIBSAIS_VER}.tar.gz
      PREFIX ${CMAKE_CURRENT_BINARY_DIR}/libsais-${LIBSAIS_VER}
      BUILD_IN_SOURCE 1
      DOWNLOAD_EXTRACT_TIMESTAMP false
      CONFIGURE_COMMAND cmake .
      BUILD_COMMAND cmake --build .
      INSTALL_COMMAND ""
    )
  endif()


  add_library(libsais STATIC IMPORTED)
  add_dependencies(libsais libsais_project)

  ExternalProject_Get_Property(libsais_project SOURCE_DIR)
  link_directories(${SOURCE_DIR})
  include_directories(${SOURCE_DIR}/include)

  # find_library(LIBLIBSAIS libsais PATHS ${SOURCE_DIR} NO_DEFAULT_PATH)
  set_property(TARGET libsais PROPERTY IMPORTED_LOCATION ${SOURCE_DIR}/liblibsais.a)

  link_libraries(libsais)
  add_definitions(-DUSE_SAIS -DLIBSAIS_OPENMP)
endif()

add_executable(bowtie2-align-s ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-align-l ${SEARCH_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-s ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-build-l ${BUILD_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-s ${INSPECT_CPPS} ${SHARED_CPPS})
add_executable(bowtie2-inspect-l ${INSPECT_CPPS} ${SHARED_CPPS})

set_target_properties(bowtie2-align-l bowtie2-build-l PROPERTIES COMPILE_FLAGS "-DBOWTIE_64BIT_INDEX")
set_target_properties(bowtie2-inspect-l PROPERTIES COMPILE_FLAGS "-DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN")
set_target_properties(bowtie2-inspect-s PROPERTIES COMPILE_FLAGS "-DBOWTIE_INSPECT_MAIN")

install(TARGETS ${BOWTIE2_BIN_LIST} DESTINATION bin)
install(FILES ${BOWTIE2_WRAPPER_SCRIPTS}
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
  DESTINATION bin)

add_test(NAME simple-align
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2 -x example/index/lambda_virus example/reads/longreads.fq -u 10)
# Small index
add_test(NAME simple-build-small
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2-build-s -c GGGCGGCGACCTCGCGGGTTTTCGCTA out)
add_test(NAME simple-inspect-small
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2-inspect-s out && rm out*)
# Large index
add_test(NAME simple-build-large
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2-build-l -c GGGCGGCGACCTCGCGGGTTTTCGCTA out)
add_test(NAME simple-inspect-large
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
  COMMAND bowtie2-inspect-l out && rm out*)

=== Makefile ===
#
# Copyright 2011, Ben Langmead <langmea@cs.jhu.edu>
#
# This file is part of Bowtie 2.
#
# Bowtie 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Bowtie 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bowtie 2.  If not, see <http://www.gnu.org/licenses/>.
#

#
# Makefile for bowtie, bowtie2-build, bowtie2-inspect
#

PREFIX := /usr/local
bindir := $(PREFIX)/bin

LDLIBS := -lpthread -lz

HEADERS := $(wildcard *.h)
BOWTIE_MM := 1
BOWTIE_SHARED_MEM :=

CXXFLAGS += -std=c++11 -Wall -Wno-unused-but-set-variable

SRA_TOOLS_VER ?= 3.0.9
VDB_VER ?= 3.0.9

ifneq (,$(findstring $(shell uname),Linux))
  LDLIBS += -lrt
endif

# Detect Cygwin or MinGW
ifneq (,$(findstring mingw,$(shell $(CXX) --version)))
  WINDOWS := 1
  MINGW := 1
endif

ifeq (1, $(MINGW))
  LDLIBS := $(subst -lrt,,$(LDLIBS))
  CXX = x86_64-w64-mingw32-g++-posix
  CC  = x86_64-w64-mingw32-gcc-posix
  AR  = x86_64-w64-mingw32-ar
  RC  = x86_64-w64-mingw32-windres
  LD  = x86_64-w64-mingw32-ld
  STRIP = x86_64-w64-mingw32-strip
endif

# POSIX memory-mapped files not currently supported on Windows
ifeq (1, $(WINDOWS))
  BOWTIE_MM :=
  BOWTIE_SHARED_MEM :=
  # and no support for advanced vectorization either
  SSE_AVX2 := 0
endif

MACOS :=
ifneq (,$(findstring Darwin,$(shell uname)))
  MACOS := 1
  ifeq (1,$(shell uname -r | awk -F. '{ if ($$1 > 12 && $$1 < 16) print 1; }'))
	CXXFLAGS += -stdlib=libstdc++
  endif
  ifdef STATIC_BUILD
	CXXFLAGS += -mmacosx-version-min=10.9
  endif
endif

# do we have a 256-bit variant of the executable?
ENABLE_V256 := 0

BITS := 32
ARCH ?= $(shell uname -m)
ifneq (,$(findstring $(ARCH), x86_64 amd64))
  BITS := 64
  SSE_FLAG := -msse2
  POPCNT_CAPABILITY ?= 1
  ifneq (0, $(SSE_AVX2))
    ENABLE_V256 := 1
    V256_FLAG := -march=x86-64-v3 -mtune=znver3 -faligned-new -DSSE_AVX2 -DPOPCNT_CAPABILITY
    # tell 128-bit version to check for v256 capability and use it, if found
    SSE_FLAG += -DENABLE_x86_64_v3
  endif
else ifneq (,$(findstring $(ARCH), aarch64 arm64 s390x powerpc64 powerpc64le ppc64 ppc64le))
  BITS := 64
  SSE_FLAG :=
  CXXFLAGS += -fopenmp-simd
  CPPFLAGS += -Ithird_party
  POPCNT_CAPABILITY ?= 0
endif

ifeq (1, $(if $(or $(USE_SAIS),$(USE_SAIS_OPENMP)),1))
  CPPFLAGS += -Ithird_party/libsais/include
ifdef USE_SAIS_OPENMP
  BUILD_CXXFLAGS += -fopenmp
endif
  BUILD_CXXFLAGS += -DUSE_SAIS
  BUILD_LDFLAGS += -Lthird_party/libsais/lib
  BUILD_LDLIBS += -lsais
endif

# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
  ifeq (1,$(MINGW))
    BITS := 64
  endif
endif
ifeq (32,$(BITS))
  $(error bowtie2 compilation requires a 64-bit platform )
endif

ifdef STATIC_BUILD
  WITH_ZSTD = 1
  LDFLAGS += -L$(CURDIR)/.tmp/lib
  CPPFLAGS += -I$(CURDIR)/.tmp/include
endif

ifeq (1, $(POPCNT_CAPABILITY))
  CXXFLAGS += -DPOPCNT_CAPABILITY
  CPPFLAGS += -I third_party
endif

MM_DEF :=

ifeq (1,$(BOWTIE_MM))
  MM_DEF := -DBOWTIE_MM
endif

SHMEM_DEF :=

ifdef BOWTIE_SHARED_MEM
  SHMEM_DEF := -DBOWTIE_SHARED_MEM
endif

PTHREAD_PKG :=
PTHREAD_LIB :=

ifeq (1,$(MINGW))
  PTHREAD_LIB :=
else
  PTHREAD_LIB := -lpthread
endif

ifeq (1,$(NO_SPINLOCK))
  CXXFLAGS += -DNO_SPINLOCK
endif

USE_SRA ?=
ifeq (1, $(USE_SRA))
  ifdef MINGW
    $(error "SRA binaries cannot be built on MINGW")
  else
    LDFLAGS += -L$(CURDIR)/.tmp/lib64
    ifndef ($(STATIC_BUILD))
      CPPFLAGS += -I$(CURDIR)/.tmp/include
    endif
    ALIGN_LDLIBS += -lncbi-ngs-static
    ALIGN_LDLIBS += -lncbi-vdb-static
    ALIGN_LDLIBS += -ldl
    CXXFLAGS += -DUSE_SRA
  endif
endif

ifeq (1,$(WITH_THREAD_PROFILING))
  CXXFLAGS += -DPER_THREAD_TIMING=1
endif

ifeq (1,$(WITH_AFFINITY))
  CXXFLAGS += -DWITH_AFFINITY=1
endif

#default is to use queue lock for better thread scaling performance
ifneq (1,$(NO_QUEUELOCK))
  CXXFLAGS += -DNO_SPINLOCK
  CXXFLAGS += -DWITH_QUEUELOCK=1
endif

SHARED_CPPS :=  ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
  edit.cpp bt2_locks.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
  reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
  random_source.cpp

SEARCH_CPPS :=  qual.cpp pat.cpp sam.cpp \
  read_qseq.cpp aligner_seed_policy.cpp \
  aligner_seed.cpp \
  aligner_seed2.cpp \
  aligner_sw.cpp \
  aligner_sw_driver.cpp aligner_cache.cpp \
  aligner_result.cpp ref_coord.cpp mask.cpp \
  pe.cpp aln_sink.cpp dp_framer.cpp \
  scoring.cpp presets.cpp unique.cpp \
  simple_func.cpp \
  random_util.cpp \
  aligner_bt.cpp sse_util.cpp \
  aligner_swsse.cpp outq.cpp \
  aligner_swsse_loc_i16.cpp \
  aligner_swsse_ee_i16.cpp \
  aligner_swsse_loc_u8.cpp \
  aligner_swsse_ee_u8.cpp \
  aligner_driver.cpp

ifeq (1, $(WITH_ZSTD))
  LDLIBS += -lzstd
  CXXFLAGS += -DWITH_ZSTD
  SHARED_CPPS += zstd_decompress.cpp
endif

SEARCH_CPPS_MAIN := $(SEARCH_CPPS) bowtie_main.cpp

DP_CPPS := qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
  simple_func.cpp sse_util.cpp aligner_bt.cpp aligner_swsse.cpp \
  aligner_swsse_loc_i16.cpp aligner_swsse_ee_i16.cpp \
  aligner_swsse_loc_u8.cpp aligner_swsse_ee_u8.cpp scoring.cpp

BUILD_CPPS := diff_sample.cpp
BUILD_CPPS_MAIN := $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS := $(wildcard search_*_phase*.c)
VERSION := $(shell cat BOWTIE2_VERSION)

SANITIZER_FLAGS :=
ifeq (0,$(shell $(CXX) -E -fsanitize=address,undefined btypes.h > /dev/null 2>&1; echo $$?))
  SANITIZER_FLAGS := -fsanitize=address,undefined
else ifeq (0,$(shell $(CXX) -E -fsanitize=address btypes.h > /dev/null 2>&1; echo $$?))
  SANITIZER_FLAGS := -fsanitize=address
else ifeq (0,$(shell $(CXX) -E -fsanitize=undefined btypes.h > /dev/null 2>&1; echo $$?))
  SANITIZER_FLAGS := -fsanitize=undefined
endif

DEBUG_FLAGS    := -O0 -g3
RELEASE_FLAGS  := -O3 -funroll-loops -g3
NOASSERT_FLAGS := -DNDEBUG
FILE_FLAGS     := -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(CXXFLAGS)\""
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(CXXFLAGS)\""

ifeq (1, $(ENABLE_V256))
  V256_DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(CXXFLAGS) $(V256_FLAG)\""
  V256_RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(CXXFLAGS) $(V256_FLAG)\""
endif


BOWTIE2_BIN_BOTH_LIST := bowtie2-build-s \
  bowtie2-build-l \
  bowtie2-align-s \
  bowtie2-align-l
BOWTIE2_BIN_BOTH_LIST_DBG := bowtie2-build-s-debug \
  bowtie2-build-l-debug \
  bowtie2-align-s-debug \
  bowtie2-align-l-debug
BOWTIE2_BIN_BOTH_LIST_SAN := bowtie2-build-s-sanitized \
  bowtie2-build-l-sanitized \
  bowtie2-align-s-sanitized \
  bowtie2-align-l-sanitized

ifeq (1, $(ENABLE_V256))
  BOWTIE2_BIN_BOTH_LIST += bowtie2-align-s-v256 bowtie2-align-l-v256
  BOWTIE2_BIN_BOTH_LIST_DBG += bowtie2-align-s-debug-v256 bowtie2-align-l-debug-v256
  BOWTIE2_BIN_BOTH_LIST_SAN += bowtie2-align-s-sanitized-v256 bowtie2-align-l-sanitized-v256
endif

BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_BOTH_LIST) \
  bowtie2-inspect-s \
  bowtie2-inspect-l
BOWTIE2_BIN_LIST_DBG := $(BOWTIE2_BIN_BOTH_LIST_DBG) \
  bowtie2-inspect-s-debug \
  bowtie2-inspect-l-debug
BOWTIE2_BIN_LIST_SAN := $(BOWTIE2_BIN_BOTH_LIST_SAN) \
  bowtie2-inspect-s-sanitized \
  bowtie2-inspect-l-sanitized
ifndef SANITIZER_FLAGS
        BOWTIE2_BIN_LIST_SAN =
endif

GENERAL_LIST := $(wildcard scripts/*.sh) \
  $(wildcard scripts/*.pl) \
  doc/manual.html \
  doc/README \
  doc/style.css \
  $(wildcard example/index/*.bt2) \
  $(wildcard example/reads/*.fq) \
  $(wildcard example/reads/*.pl) \
  example/reads/combined_reads.bam \
  example/reference/lambda_virus.fa \
  $(PTHREAD_PKG) \
  bowtie2 \
  bowtie2-build \
  bowtie2-inspect \
  AUTHORS \
  LICENSE \
  NEWS \
  MANUAL \
  MANUAL.markdown \
  README.md \
  TUTORIAL \
  BOWTIE2_VERSION

ifeq (1,$(WINDOWS))
  BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
  CXXFLAGS += -static-libgcc -static-libstdc++ -static
endif

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND := $(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
  $(wildcard *.hh) \
  $(wildcard *.c) \
  $(wildcard *.cpp) \
  $(wildcard third_party/*) \
  Makefile \
  CMakeLists.txt \
  $(GENERAL_LIST)

ifeq (1,$(WINDOWS))
  BIN_PKG_LIST := $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
else
  BIN_PKG_LIST := $(GENERAL_LIST)
endif

.PHONY: all allall both both-debug

all: $(BOWTIE2_BIN_LIST) ;
allall: $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_DBG) $(BOWTIE2_BIN_LIST_SAN) ;
both: $(BOWTIE2_BIN_BOTH_LIST) ;
both-debug: $(BOWTIE2_BIN_BOTH_LIST_DBG) ;
both-sanitized: $(BOWTIE2_BIN_BOTH_LIST_SAN) ;

DEFS := -fno-strict-aliasing \
  -DBOWTIE2_VERSION="\"`cat BOWTIE2_VERSION`\"" \
  -DBUILD_HOST="\"$${HOSTNAME:-`hostname`}\"" \
  -DBUILD_TIME="\"`date -u`\"" \
  -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
  $(FILE_FLAGS) \
  $(PREF_DEF) \
  $(MM_DEF) \
  $(SHMEM_DEF)

# set compiler flags for all sanitized builds
ifdef BOWTIE2_BIN_LIST_SAN
$(BOWTIE2_BIN_LIST_SAN): CXXFLAGS+=$(SANITIZER_FLAGS)
else
$(BOWTIE2_BIN_LIST_SAN): $(error "Compiler does not support...")
endif

bowtie2-build-%: CXXFLAGS += $(BUILD_CXXFLAGS)
bowtie2-build-%: LDFLAGS += $(BUILD_LDFLAGS)
bowtie2-build-%: LDLIBS += $(BUILD_LDLIBS)

bowtie2-align-%: LDLIBS += $(ALIGN_LDLIBS)
#
# bowtie2-build targets
#
bowtie2-build-s-sanitized bowtie2-build-s: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS)  \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-sanitized bowtie2-build-l: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS)  \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-s-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2  \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-build-l-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX  \
		$(CPPFLAGS) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

#
# bowtie2-align targets
#

bowtie2-align-s-sanitized bowtie2-align-s: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) \
		$(CPPFLAGS) $(SSE_FLAG) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-sanitized bowtie2-align-l: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS)  \
		$(CPPFLAGS) $(SSE_FLAG) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-s-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2  \
		$(CPPFLAGS) $(SSE_FLAG) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LDFLAGS) $(LDLIBS)

bowtie2-align-l-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(CXXFLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX  \
		$(CPPFLAGS) $(SSE_FLAG) \
		-o $@ $< \

=== debian/changelog ===
bowtie2 (2.5.5-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * Adjusted patches.

  [ Andreas Tille ]
  * d/watch: version=5

 -- Steffen Moeller <moeller@debian.org>  Sun, 22 Feb 2026 15:11:39 +0000

=== debian/control ===
Source: bowtie2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Alexandre Mestiashvili <mestia@debian.org>,
           Andreas Tille <tille@debian.org>,
           Steffen Moeller <moeller@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               architecture-is-64-bit,
               architecture-is-little-endian,
               help2man,
               pandoc <!nodoc>,
               libtbb-dev,
               python3,
               liblocal-lib-perl,
               libtest-deep-perl <!nocheck>,
               libclone-perl <!nocheck>,
               libfile-which-perl <!nocheck>,
               zlib1g-dev,
               libsimde-dev
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
Homepage: https://bowtie-bio.sourceforge.net/bowtie2
Rules-Requires-Root: no

Package: bowtie2
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${shlibs:Depends},
         ${perl:Depends}
Suggests: bowtie2-examples
Built-Using: ${simde:Built-Using}
Description: ultrafast memory-efficient short read aligner
 is an ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes

Package: bowtie2-examples
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: bowtie2
Enhances: bowtie2
Description: Examples for bowtie2
 An ultrafast and memory-efficient tool for aligning sequencing reads
 to long reference sequences. It is particularly good at aligning reads
 of about 50 up to 100s or 1,000s of characters, and particularly good
 at aligning to relatively long (e.g. mammalian) genomes.
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes
 .
 This package provides some example data to work with bowtie2.

=== debian/watch ===
Version: 5

Template: Github
Owner: BenLangmead
Project: bowtie2
